#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal
#
###2006-0422 - install.pl from QoS v1.8 by NetWhiz modded by catastrophe for use with enhancedipblock v.0.2
###2007-0107 - modded by catastrophe for use with NoWireAP v.0.2.0
###2007-0122 - modded by catastrophe for use with NoWireAP v.0.2.0
###2007-0914 - modded by catastrophe for use with Connview v.0.9
# - "check Smoothwall version" adapted from install script of Crontool v3.0c mod by s-t-p
###


# # # # # # #
# variables #
# # # # # # #

# modlib directories
my $bkp = '/var/smoothwall/mods/connview/backup';
my $mod = '/var/smoothwall/mods/connview/modfiles';	# mod files stored here
my $param = '/var/smoothwall/mods/connview/params';	# modlib parameters stored here

require '/var/smoothwall/mods/connview/modlib.pl';	# require modlib

# # # # # # # # # # # # # #
# check Smoothwall verson #
# # # # # # # # # # # # # #

if (!(-e "/usr/lib/smoothwall/langs/base.pl")) {
	print "\nYou are not running SmoothWall Express version 3.0\n \n";
	print "This version of the Connview mod requires SWE 3.0\n \n";
	print "Terminating Connview mod installation.\n";
	exit;
}

# # # # # # # # # # # # # # # # # # #
# check for existing installations  #
# # # # # # # # # # # # # # # # # # #

print "\nInstalling Connview v.0.9, please wait...\n\n";

if (&installed ("/usr/lib/smoothwall/langs/base.pl", "# connview v.0.9")) {
	print "\nPlease remove # connview v.0.9 \n";
	print "Note - Run uninstall.pl script.\n \n";
	exit;
}

if (-e "/var/smoothwall/mods/connview/installed") {
	if (&installed ("/var/smoothwall/mods/connview/installed", "# connview v.0.9")) {
		print "\nPlease remove # connview v.0.9 \n";
		print "Note - Run uninstall.pl script.\n \n";
		exit;
	}
}

# # # # # # # # # # # #
# handle file copying #
# # # # # # # # # # # #

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file, $wkdir, $storebkp, $moddir);
#	backup ($file, $wkdir, $storebkp);
#	install ($file, $wkdir, $moddir);
#	uninstallrestore ($file, $wkdir, $storebkp);
#	uninstall ($file , $wkdir);
#
#	installed ($file, $string);
#
#	search for $string into $file => 1 found / 0 not found

print "Creating backups ...\n";

$dir = '/httpd/cgi-bin';
&backup ('.htaccess', $dir, $bkp);

$dir = '/usr/lib/smoothwall/langs';
&backup ('base.pl', $dir, $bkp);

$dir = '/usr/lib/smoothwall/langs';
&backup ('alertboxes.base.pl', $dir, $bkp);

print "Installing new files ...\n";

$dir = '/httpd/cgi-bin';
&install ('connview.cgi', $dir, $mod);

$dir = '/httpd/html/help';
&install ('connview.cgi.html.en', $dir, $mod);

$dir = '/usr/lib/smoothwall/menu/1000_About';
&install ('1515_connview.list', $dir, $mod);

# # # # # # # # # # # #
# handle permissions  #
# # # # # # # # # # # #

print "Making any needed directories ...\n";

# make sure classic modlib mods install to directory exists
open (FILE, ">/var/smoothwall/mods/dummy") or system ("/bin/su nobody -c '/bin/mkdir /var/smoothwall/mods'");
close (FILE);
system ("/bin/rm -f /var/smoothwall/mods/dummy");

# remove these lines when the web UI interface is ready
#open (FILE, ">/var/smoothwall/preferences/dummy") or system ("/bin/su nobody -c '/bin/mkdir /var/smoothwall/preferences'");
#close (FILE);
#system ("/bin/rm -f /var/smoothwall/preferences/dummy");

# uncomment these lines when the web UI interface is ready
#open (FILE, ">/var/smoothwall/preferences/dummy") or system ("/bin/mkdir /var/smoothwall/preferences");
#close (FILE);
#system ("/bin/rm -f /var/smoothwall/preferences/dummy");

# # # # # # # # # # # #
# handle file editing #
# # # # # # # # # # # #

&easymod ("/httpd/cgi-bin/.htaccess", "$param/htaccess.09.s", '3', "$param/htaccess.09.r");

&easymod ("/usr/lib/smoothwall/langs/alertboxes.base.pl", "$param/alertboxes.base.pl.09.s", '0', "$param/alertboxes.base.pl.09.r");

&easymod ("/usr/lib/smoothwall/langs/base.pl", "$param/base.pl.09.s", '0', "$param/base.pl.09.r");

# # # # # # # # # # # #
# handle file linking #
# # # # # # # # # # # #

$dir = "/var/smoothwall/mods/connview";
&install ('installed', $dir, $mod);

print "\nDone\n\n";

# # # #
# end #
# # # #
