#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
### 2007-0914 - Connview v.0.9 mod by catastrophe
# - Tested for use on SmoothWall Express 3.0-polar-i386 (kernel v2.6.16.53)
# - Inspired by the connects.cgi mod by DavidVT for SWE2
# - Reused some code from Connview v.0.8-test1 mod by catastrophe for SWE2, not all features ported over yet.
# - Implementation of modlib v2.3 pack system by Tiago Freitas Leal and Drew S. Dupont (NetWhiz) from QoS v1.8 mod
#    with "check Smoothwall version" adapted from install script of Crontool v3.0c mod by s-t-p
# - Used ipblock.cgi from SWE3.0 by The Smoothwall Team as a CGI template
# - Source and remote IP checkboxes for use with "Lookup" and "Add to IP block list" and 
#    $ENV{'QUERY_STRING'} subroutine from firewalllog.dat by The Smoothwall Team
# - Adapted masqueraded connection determination method and name/port resolution from CONNTRACK-VIEWER v1.3 by Patrick Lagace
# - Borrowed "ip2number" subroutine from dhcplease.pl v0.2.5 (DHCP Pack v1.3) for SWE2.0 
#    by Dane Robert Jones and Tiago Freitas Leal
# - With tweaking, incorporated "in script sorting" code contributed by Daniel Hokka Zakrisson (daniel_hozac)
# - Data gathering of /proc/net/ip_conntrack done by helper file (Thanks SwampKracker, daniel_hozac, & NetWhiz)
# - Stripped connviewhelper to reduce file size (thanks NetWhiz)
# - Rewrote protocol interpretation supporting tcp, udp, and icmp for use with SWE3.0
# - Borrowed parts of "displaytable" subroutine from smoothtype.pm from SWE3.0 by the SmoothWall Team
# - Thanks to Stanford T. Prescott (s-t-p) for his "[3.0] HowTo Add Your Mod to the SmoothWall Admin GUI" 
###
#
# - Disclaimer:
#    - Use at your own risk without any or implied warranty.
###

use lib "/usr/lib/smoothwall";
use header qw( :standard );
#use smoothd qw( message );
#use smoothtype qw( :standard );

use Socket;

my %netsettings;
&readhash("${swroot}/ethernet/settings", \%netsettings);
$netsettings{'GREEN_NETADDRESS'} =~ /.0$/; $GREEN_NET = $`;
$netsettings{'ORANGE_NETADDRESS'} =~ /.0$/; $ORANGE_NET = $`;
$netsettings{'RED_NETADDRESS'} =~ /.0$/; $RED_NET = $`;
$netsettings{'BLUE_NETADDRESS'} =~ /.0$/; $BLUE_NET = $`;
$netsettings{'PURPLE_NETADDRESS'} =~ /.0$/; $PURPLE_NET = $`;
$L0CALH0ST = "127.0.0.1";
$redip = '0.0.0.0';
open(FILE, "${swroot}/red/local-ipaddress");
$redip = <FILE>; chomp $redip;
close(FILE);

my (%cgiparams,%checked,%selected);
my ($var, $val);

$catLINEnumber='';
$catprot='';	#0
$catprotn='';	#1
$catprote='';	#2
$catstat='';	#3
$catsrci='';	#4
$catdsti='';	#5
$catsrcp='';	#6
$catdstp='';	#7
$catpack='';	#8
$catbyte='';	#9
$catsrc2i='';	#10
$catdst2i='';	#11
$catsrc2p='';	#12
$catdst2p='';	#13
$catpack2='';	#14
$catbyte2='';	#15
$catqual='';	#16
$catmark='';	#17
$catuse='';	#18
$catmasq='';	#19
$catsrcin='';
$catdstin='';
$catip='';
$catdnsname='';
$catport='';
$catportname='';

$catgreen = "#60aa60";
$catorange = "#ff9900";
$catred = "#ff6060";
$catwhite = "#ffffff";
$catblue = "#0000ff";
$catpurple = "#800080";

$connMASQcount=0;
$connDIRECTcount=0;
$connTOTALcount=0;
$connMASQcountESTABLISHED=0;
$connDIRECTcountESTABLISHED=0;
$connTOTALcountESTABLISHED=0;
$connMASQcountTCP=0;
$connDIRECTcountTCP=0;
$connTOTALcountTCP=0;
$connMASQcountUDP=0;
$connDIRECTcountUDP=0;
$connTOTALcountUDP=0;
$connMASQcountICMP=0;
$connDIRECTcountICMP=0;
$connTOTALcountICMP=0;
$connMASQcountOTHER=0;
$connDIRECTcountOTHER=0;
$connTOTALcountOTHER=0;

if ($ENV{'QUERY_STRING'})
{
	$_ = $ENV{'QUERY_STRING'};
	my $action;
	$_ =~ s/\+/ /g;
	my @temp = split(/\&/);
	foreach $_ (@temp)
	{
		($var, $val) = split(/\=/);
		if ($var eq 'ACTION') {
			$action = $val; }
	}

	if ($action eq $tr{'add to ip block'})
	{
		print "Status: 302 Moved\n";
		print "Location: /cgi-bin/ipblock.cgi?$ENV{'QUERY_STRING'}\n\n";
		exit 0;
	}
	if ($action eq $tr{'lookup'})
	{
		print "Status: 302 Moved\n";
		print "Location: /cgi-bin/ipinfo.cgi?$ENV{'QUERY_STRING'}\n\n";
		exit 0;
	}
}

&showhttpheaders();

$connviewsettings{'ACTION'} = '';
$connviewsettings{'CONN_NAME'} = 'off';
$connviewsettings{'CONN_COLOR'} = 'off';
$connviewsettings{'CONN_SORT'} = 'on';
$connviewsettings{'CONN_COLUMN'} = '0';
$connviewsettings{'CONN_REVERSE'} = 'off';
$connviewsettings{'CONN_RAW'} = 'off';
$connviewsettings{'CONN_NETSTAT'} = 'off';
$connviewsettings{'CONN_SUMMARY'} = 'on';
$connviewsettings{'CONN_MASQ'} = 'on';
&getcgihash(\%connviewsettings);

my $errormessage = '';

if ($connviewsettings{'ACTION'} eq $tr{'update'})
{
	if ($connviewsettings{'CONN_COLUMN'} eq 0) {
 		$connviewsettings{'CONN_SORT'}='off';
	}
	&writehash("${swroot}/tmp/connview", \%connviewsettings);
}

system ("/bin/touch ${swroot}/tmp/connview");
&readhash("${swroot}/tmp/connview", \%connviewsettings);

$selected{'CONN_DISPLAY'}{'both'} = '';
$selected{'CONN_DISPLAY'}{'masq'} = '';
$selected{'CONN_DISPLAY'}{'direct'} = '';
$selected{'CONN_DISPLAY'}{'mixed'} = '';
$selected{'CONN_DISPLAY'}{$connviewsettings{'CONN_DISPLAY'}} = 'SELECTED';

$checked{'CONN_NAME'}{'on'} = '';
$checked{'CONN_NAME'}{'off'} = '';
$checked{'CONN_NAME'}{$connviewsettings{'CONN_NAME'}} = 'CHECKED';

$checked{'CONN_COLOR'}{'on'} = '';
$checked{'CONN_COLOR'}{'off'} = '';
$checked{'CONN_COLOR'}{$connviewsettings{'CONN_COLOR'}} = 'CHECKED';

$checked{'CONN_TRUNCATE'}{'on'} = '';
$checked{'CONN_TRUNCATE'}{'off'} = '';
$checked{'CONN_TRUNCATE'}{$connviewsettings{'CONN_TRUNCATE'}} = 'CHECKED';

$checked{'CONN_RAW'}{'on'} = '';
$checked{'CONN_RAW'}{'off'} = '';
$checked{'CONN_RAW'}{$connviewsettings{'CONN_RAW'}} = 'CHECKED';

$checked{'CONN_NETSTAT'}{'on'} = '';
$checked{'CONN_NETSTAT'}{'off'} = '';
$checked{'CONN_NETSTAT'}{$connviewsettings{'CONN_NETSTAT'}} = 'CHECKED';

$checked{'CONN_SORT'}{'on'} = '';
$checked{'CONN_SORT'}{'off'} = '';
$checked{'CONN_SORT'}{$connviewsettings{'CONN_SORT'}} = 'CHECKED';

$selected{'CONN_COLUMN'}{'0'} = '';
$selected{'CONN_COLUMN'}{'1'} = '';
$selected{'CONN_COLUMN'}{'2'} = '';
$selected{'CONN_COLUMN'}{'3'} = '';
$selected{'CONN_COLUMN'}{'4'} = '';
$selected{'CONN_COLUMN'}{'5'} = '';
$selected{'CONN_COLUMN'}{'6'} = '';
$selected{'CONN_COLUMN'}{'7'} = '';
$selected{'CONN_COLUMN'}{'19'} = '';
$selected{'CONN_COLUMN'}{'20'} = '';
$selected{'CONN_COLUMN'}{'21'} = '';
$selected{'CONN_COLUMN'}{$connviewsettings{'CONN_COLUMN'}} = 'SELECTED';

$checked{'CONN_REVERSE'}{'on'} = '';
$checked{'CONN_REVERSE'}{'off'} = '';
$checked{'CONN_REVERSE'}{$connviewsettings{'CONN_REVERSE'}} = 'CHECKED';

&openpage("Connection Viewer", 1, '', 'about your smoothie');
&openbigbox('100%', 'LEFT');
&alertbox($errormessage);

&openbox("Conntrack Viewer:<br>");
print qq|
<FORM METHOD='POST' ACTION='/cgi-bin/connview.cgi'>
|;
print qq|
<table width='100%' border='0' cellspacing='0' cellpadding='0'>
<TR>
|;
print qq|
	<TD CLASS='base'>
	Color:
	<INPUT TYPE='checkbox' NAME='CONN_COLOR' $checked{'CONN_COLOR'}{'on'}>
	</TD>
	<TD CLASS='base'>
	Name Resolution: 
	<INPUT TYPE='checkbox' NAME='CONN_NAME' $checked{'CONN_NAME'}{'on'}>
	</TD>
|;
print qq|
	<TD CLASS='base'>Sort By:
	<SELECT NAME='CONN_COLUMN'>
		<OPTION VALUE='0' $selected{'CONN_COLUMN'}{'0'}>None
		<OPTION VALUE='1' $selected{'CONN_COLUMN'}{'1'}>Protocol
		<OPTION VALUE='2' $selected{'CONN_COLUMN'}{'2'}>Expires
		<OPTION VALUE='3' $selected{'CONN_COLUMN'}{'3'}>State
		<OPTION VALUE='20' $selected{'CONN_COLUMN'}{'20'}>Source IP
		<OPTION VALUE='6' $selected{'CONN_COLUMN'}{'6'}>Source Port
		<OPTION VALUE='21' $selected{'CONN_COLUMN'}{'21'}>Remote IP
		<OPTION VALUE='7' $selected{'CONN_COLUMN'}{'7'}>Remote Port
		<OPTION VALUE='19' $selected{'CONN_COLUMN'}{'19'}>?
	</SELECT>
	</TD>
	<TD CLASS='base'>Reverse Sort:
	<INPUT TYPE='checkbox' NAME='CONN_REVERSE' $checked{'CONN_REVERSE'}{'on'}>
	</TD>
	<TD CLASS='base'>Show Raw:
	<INPUT TYPE='checkbox' NAME='CONN_RAW' $checked{'CONN_RAW'}{'on'}>
	</TD>
	<TD CLASS='base'>Netstat:
	<INPUT TYPE='checkbox' NAME='CONN_NETSTAT' $checked{'CONN_NETSTAT'}{'on'}>
	</TD>
	<TD ALIGN='CENTER'><INPUT TYPE='submit' NAME='ACTION' VALUE='$tr{'update'}'></TD>
</TR>
</TABLE>
|;
print "</FORM>";
&closebox();

&openbox("Active and masqueraded connections<br>");
###https://192.168.1.1:441/cgi-bin/ipinfo.cgi?ip=77.77.77.77&ACTION=Lookup
print "<FORM METHOD='GET'>\n";
my ( $table1colour, $table2colour ) = ( '#f0f0f0', '#e0e0e0' );
my $colour = "background-color: $table2colour;";
print qq|
<table class='list'>
<tr>
	<th class='list' style='width: 15%; $colour'>Protocol</th>
	<th class='list' style='width: 10%; $colour'>Expires</th>
	<th class='list' style='width: 10%; $colour'>State</th>
	<th class='list' style='width: 1%; $colour'></th>
	<th class='list' style='width: 15%; $colour'>Source IP</th>
	<th class='list' style='width: 10%; $colour'>Port</th>
	<th class='list' style='width: 1%; $colour'></th>
	<th class='list' style='width: 15%; $colour'>Remote IP</th>
	<th class='list' style='width: 10%; $colour'>Port</th>
|;
print "</tr>";
my @ip_conntrack_data;
my @ip_conntrack_sort;
@ip_conntrack_data = `/var/smoothwall/mods/connview/modfiles/connviewhelper`;
#@ip_conntrack_data = `cat /tmp/data.txt`;
#@ip_conntrack_data = `cat /tmp/debug.txt`;
chomp (@ip_conntrack_data);
for ($i=0; $i <= $#ip_conntrack_data; $i++){
	$proto = $ip_conntrack_data[$i];
	chomp ($proto);
	&conntrackPROTOCOLinterpretation();
	&connviewCOUNT();
}
for ($i = 0; $i <= $#ip_conntrack_sort; $i++) {
	if ( $colour eq "background-color: $table1colour;" ){
		$colour = "background-color: $table2colour;";
	} else {
		$colour = "background-color: $table1colour;";
	}
	$catLINEnumber = $i+1;
	if ($connviewsettings{'CONN_SORT'} eq "on") {	###in script sorting
		@ip_conntrack_sort = sort { &conntrackCOMPARE(); } @ip_conntrack_sort;
	}
	&connviewPOSTSORT();
	print qq|
	<tr class='list'>
		<td class='list' style='$colour'>$catprot($catprotn)</td>
		<td class='list' style='$colour'>$catprote</td>
		<td class='list' style='$colour'>$catstat</td>
	|;
	print qq|
		<td class='list' style='$colour'><INPUT TYPE='checkbox' NAME='ip' VALUE='$catsrci'></td>
		<td class='list' style='$colour'>
	|;
	$colormenow1=$catsrci; $colormenow2=$catsrci; &connviewCOLORmeNOW();
	if ($connviewsettings{'CONN_MASQ'} eq 'on') {
		if ($catmasq ne "") {
			print "&nbsp;&nbsp;$catmasq";	
		}
	}
	print qq|
		</td>
		<td class='list' style='$colour'>$catsrcp</td>
	|;
	print qq|
		<td class='list' style='$colour'><INPUT TYPE='checkbox' NAME='ip' VALUE='$catdsti'></td>
		<td class='list' style='$colour'>
	|;
	$colormenow1=$catdsti; $colormenow2=$catdsti; &connviewCOLORmeNOW();
	print qq|
		</td>
		<td class='list' style='$colour'>$catdstp</td>
	|;
	print "</tr>";
	if ($connviewsettings{'CONN_NAME'} eq "on") {
		print qq|
		<tr class='list'><td style='$colour' colspan='21'><center>
		|;
		if ($catsrci ne "") {
			$catsrcin=&connviewNAME2($catsrci);
			$colormenow1=$catsrci; $colormenow2=$catsrcin; &connviewCOLORmeNOW();
			if ($catsrcp ne "") {
				$catsrcpn=&connviewNAME3($catsrcp,$catprot);
				print ":($catsrcpn)";
			}
			print " <===> ";
			$catdstin=&connviewNAME2($catdsti);		
			$colormenow1=$catdsti; $colormenow2=$catdstin; &connviewCOLORmeNOW();
			if ($catdstp ne "") {
				$catdstpn=&connviewNAME3($catdstp,$catprot);
				print":($catdstpn)";
			}
		}
		print "</center></td></tr>";
	}	
}
print "</table>";
print qq|
<table class='blank'>
<tr>
	<td>&nbsp;</td>
</tr>
<tr>
	<td style='width: 50%; text-align: center;'><input type='submit' name='ACTION' value='$tr{'lookup'}'></td>
	<td style='width: 50%; text-align: center;'><input type='submit' name='ACTION' value='$tr{'add to ip block'}'></td>
</tr>
</table>
|;
print "</form>";

#&alertbox('add', 'add');

&closebox();

&connviewCOUNTdisplay();
&connviewRAWdisplay();
&connviewNETSTATdisplay();

&closebigbox();
&closepage($errormessage);

##########
###DONE###
##########





#################
###SUBROUTINES###
#################

sub ip2number {
	my $ip = $_[0];
	if (!($ip =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/)) {
		return 0; 
	} else {
		return ($1*(256*256*256))+($2*(256*256))+($3*256)+$4; 
	}
}

sub conntrackPROTOCOLinterpretation {
for ($proto){
	if (/^tcp/){
		######	tcp      6 8655 ESTABLISHED src=192.168.1.98 dst=192.168.1.115 sport=2416 dport=222 packets=2827 bytes=1559262 src=192.168.1.115 dst=192.168.1.98 sport=222 dport=2416 packets=1640 bytes=489181 [ASSURED] mark=0 use=1
		my @goodtimes = split(' ',$proto);
		$catprot=$goodtimes[0];
		$catprotn=$goodtimes[1];
		$catprote=$goodtimes[2];
		$catstat=$goodtimes[3];
		$catsrci=(substr $goodtimes[4], 4);
		$catdsti=(substr $goodtimes[5], 4);
		$catsrcp=(substr $goodtimes[6], 6);
		$catdstp=(substr $goodtimes[7], 6);
		$catpack=(substr $goodtimes[8], 8);
		$catbyte=(substr $goodtimes[9], 6);
		$catsrc2i=(substr $goodtimes[10], 4);
		$catdst2i=(substr $goodtimes[11], 4);
		$catsrc2p=(substr $goodtimes[12], 6);
		$catdst2p=(substr $goodtimes[13], 6);
		$catpack2=(substr $goodtimes[14], 8);
		$catbyte2=(substr $goodtimes[15], 6);
		if ($goodtimes[16] eq "[ASSURED]") {
			$catqual=$goodtimes[16];
			$catmark=(substr $goodtimes[17], 5);
			$catuse=(substr $goodtimes[18], 4);
			&connviewMASQ();
		} else {
			$catqual="";
			$catmark=(substr $goodtimes[17], 5);
			$catuse=(substr $goodtimes[18], 4);
			&connviewMASQ();
		}
		$catsrcinum=&ip2number($catsrci);
		$catdstinum=&ip2number($catdsti);
		$ip_conntrack_sort[$i] = "$catprot,$catprotn,$catprote,$catstat,$catsrci,$catdsti,$catsrcp,$catdstp,$catpack,$catbyte,$catsrc2i,$catdst2i,$catsrc2p,$catdst2p,$catpack2,$catbyte2,$catqual,$catmark,$catuse,$catmasq,$catsrcinum,$catdstinum";
	} elsif (/^udp/){
		######	udp      17 162 src=192.168.1.93 dst=69.1.1.1 sport=10000 dport=10000 packets=8952 bytes=6633326 src=69.1.1.1 dst=69.11.1.1 sport=10000 dport=10000 packets=8961 bytes=3544420 [ASSURED] mark=0 use=1
		######	udp      17 29 src=172.1.1.1 dst=255.255.255.255 sport=67 dport=68 packets=2453 bytes=865162 [UNREPLIED] src=255.255.255.255 dst=172.1.1.1 sport=68 dport=67 packets=0 bytes=0 mark=0 use=1
		my @goodtimes = split(' ',$proto);
		$catprot=$goodtimes[0];
		$catprotn=$goodtimes[1];
		$catprote=$goodtimes[2];
		$catstat="";
		$catsrci=(substr $goodtimes[3], 4);
		$catdsti=(substr $goodtimes[4], 4);
		$catsrcp=(substr $goodtimes[5], 6);
		$catdstp=(substr $goodtimes[6], 6);
		$catpack=(substr $goodtimes[7], 8);
		$catbyte=(substr $goodtimes[8], 6);
		if ($goodtimes[9] eq "[UNREPLIED]") {
			$catsrc2i=(substr $goodtimes[10], 4);
			$catdst2i=(substr $goodtimes[11], 4);
			$catsrc2p=(substr $goodtimes[12], 6);
			$catdst2p=(substr $goodtimes[13], 6);
			$catpack2=(substr $goodtimes[14], 8);
			$catbyte2=(substr $goodtimes[15], 6);
			$catqual="";
			$catmark=(substr $goodtimes[16], 5);
			$catuse=(substr $goodtimes[17], 4);
			&connviewMASQ();
		} else {
			$catsrc2i=(substr $goodtimes[9], 4);
			$catdst2i=(substr $goodtimes[10], 4);
			$catsrc2p=(substr $goodtimes[11], 6);
			$catdst2p=(substr $goodtimes[12], 6);
			$catpack2=(substr $goodtimes[13], 8);
			$catbyte2=(substr $goodtimes[14], 6);
			if ($goodtimes[15] eq "[ASSURED]") {
				$catqual=$goodtimes[15];
				$catmark=(substr $goodtimes[16], 5);
				$catuse=(substr $goodtimes[17], 4);
				&connviewMASQ();
			} else {
				$catqual="";
				$catmark=(substr $goodtimes[15], 5);
				$catuse=(substr $goodtimes[16], 4);
				&connviewMASQ();
			}
		}
		$catsrcinum=&ip2number($catsrci);
		$catdstinum=&ip2number($catdsti);
		$ip_conntrack_sort[$i] = "$catprot,$catprotn,$catprote,$catstat,$catsrci,$catdsti,$catsrcp,$catdstp,$catpack,$catbyte,$catsrc2i,$catdst2i,$catsrc2p,$catdst2p,$catpack2,$catbyte2,$catqual,$catmark,$catuse,$catmasq,$catsrcinum,$catdstinum";
	} elsif (/^icmp/){
		######	icmp 1 29 src=69.1.1.1 dst=64.1.1.1 type=8 code=0 id=11119 packets=4 bytes=336 src=64.1.1.1 dst=69.1.1.1 type=0 code=0 id=11119 packets=0 bytes=0 mark=0 use=1
		######	icmp 1 29 src=69.1.1.1 dst=64.1.1.1 type=8 code=0 id=51313 packets=2 bytes=168 [UNREPLIED] src=64.1.1.1 dst=69.1.1.1 type=0 code=0 id=51313 packets=0 bytes=0 mark=0 use=1
		my @goodtimes = split(' ',$proto);
		$catprot=$goodtimes[0];
		$catprotn=$goodtimes[1];
		$catprote=$goodtimes[2];
		$catstat="";
		$catsrci=(substr $goodtimes[3], 4);
		$catdsti=(substr $goodtimes[4], 4);
		$catsrcp="";
		$catdstp="";
		$catpack=(substr $goodtimes[8], 8);
		$catbyte=(substr $goodtimes[9], 6);
		if ($goodtimes[10] eq "[UNREPLIED]") {
			$catsrc2i=(substr $goodtimes[11], 4);
			$catdst2i=(substr $goodtimes[12], 4);
			$catsrc2p="";
			$catdst2p="";
			$catpack2=(substr $goodtimes[14], 8);
			$catbyte2=(substr $goodtimes[15], 6);
			$catmark=(substr $goodtimes[16], 5);
			$catqual="";
			$catuse=(substr $goodtimes[17], 4);
			&connviewMASQ();
		} else {
			$catsrc2i=(substr $goodtimes[10], 4);
			$catdst2i=(substr $goodtimes[11], 4);
			$catsrc2p="";
			$catdst2p="";
			$catpack2=(substr $goodtimes[15], 8);
			$catbyte2=(substr $goodtimes[16], 6);
			$catqual="";
			$catmark=(substr $goodtimes[17], 5);
			$catuse=(substr $goodtimes[18], 4);
			&connviewMASQ();
		}
		$catsrcinum=&ip2number($catsrci);
		$catdstinum=&ip2number($catdsti);
		$ip_conntrack_sort[$i] = "$catprot,$catprotn,$catprote,$catstat,$catsrci,$catdsti,$catsrcp,$catdstp,$catpack,$catbyte,$catsrc2i,$catdst2i,$catsrc2p,$catdst2p,$catpack2,$catbyte2,$catqual,$catmark,$catuse,$catmasq,$catsrcinum,$catdstinum";
	} else {
		$ip_conntrack_sort[$i] = $proto;
	}
}
}

sub connviewPOSTSORT {
	my @ip_conntrack_postsort = split(',',$ip_conntrack_sort[$i]);
	$catprot=$ip_conntrack_postsort[0];
	$catprotn=$ip_conntrack_postsort[1];
	$catprote=$ip_conntrack_postsort[2];
	$catstat=$ip_conntrack_postsort[3];
	$catsrci=$ip_conntrack_postsort[4];
	$catdsti=$ip_conntrack_postsort[5];
	$catsrcp=$ip_conntrack_postsort[6];
	$catdstp=$ip_conntrack_postsort[7];
	$catpack=$ip_conntrack_postsort[8];
	$catbyte=$ip_conntrack_postsort[9];
	$catsrc2i=$ip_conntrack_postsort[10];
	$catdst2i=$ip_conntrack_postsort[11];
	$catsrc2p=$ip_conntrack_postsort[12];
	$catdst2p=$ip_conntrack_postsort[13];
	$catpack2=$ip_conntrack_postsort[14];
	$catbyte2=$ip_conntrack_postsort[15];
	$catqual=$ip_conntrack_postsort[16];
	$catmark=$ip_conntrack_postsort[17];
	$catuse=$ip_conntrack_postsort[18];
	$catmasq=$ip_conntrack_postsort[19];
	$catsrcinum=$ip_conntrack_postsort[20];
	$catdstinum=$ip_conntrack_postsort[21];
}

sub conntrackCOMPARE {	###in script sorting (compare two conntracks)
	my (@one, @two);
	my $ret;

	$yeah = $a;
	@one = split(/\,/,$yeah);

	$yeah = $b;
	@two = split(/\,/,$yeah);

	$ret = $one[$connviewsettings{'CONN_COLUMN'}] <=> $two[$connviewsettings{'CONN_COLUMN'}];
	# <=> returns undef when the operands aren't numbers
	if ($ret == undef)
	{
		# use lexical comparison instead
		$ret = $one[$connviewsettings{'CONN_COLUMN'}] cmp $two[$connviewsettings{'CONN_COLUMN'}];
	}

	# invert
	if ($connviewsettings{'CONN_REVERSE'} eq "on")
	{
		$ret = -$ret;
	}
 
	return $ret;
}

sub connviewCOLORmeNOW {
	if ($connviewsettings{'CONN_COLOR'} eq "on") {
		if ( $colormenow1 =~ /^$GREEN_NET/ ) {
			print "<font color=$catgreen>$colormenow2</font>";
		} elsif ( $colormenow1 =~ /^$ORANGE_NET/ ) {
			print "<font color=$catorange>$colormenow2</font>";
		} elsif ( $colormenow1 =~ /^$RED_NET/ ) {
			print "<font color=$catred>$colormenow2</font>";
		} elsif ( $colormenow1 =~ /^$redip/ ) { 
			print "<font color=$catred>$colormenow2</font>";
		} elsif ( $colormenow1 =~ /^$L0CALH0ST/ ) { 
			print "<font color=$catwhite>$colormenow2</font>";
		} elsif ( $colormenow1 =~ /^$BLUE_NET/ ) { 
			print "<font color=$catblue>$colormenow2</font>";
		} elsif ( $colormenow1 =~ /^$PURPLE_NET/ ) { 
			print "<font color=$catpurple>$colormenow2</font>";
		} else {
			print "$colormenow2";	
		}
	} else {
			print "$colormenow2";
	}
}

sub connviewCOUNTdisplay {
	if ($connviewsettings{'CONN_SUMMARY'} eq "on") {
		&openbox("Connection summary<br>");
		$connTOTALcountESTABLISHED=$connMASQcountESTABLISHED+$connDIRECTcountESTABLISHED;
		$connTOTALcountTCP=$connMASQcountTCP+$connDIRECTcountTCP;
		$connTOTALcountUDP=$connMASQcountUDP+$connDIRECTcountUDP;
		$connTOTALcountICMP=$connMASQcountICMP+$connDIRECTcountICMP;
		$connTOTALcountOTHER=$connMASQcountOTHER+$connDIRECTcountOTHER;
		print "<table width='100%' border='0' cellspacing='0' cellpadding='0'>";
		print "<TR>";
		print "<TD align='right' BGCOLOR=$table1colour><TT>Masqueraded :  </TT></TD>";
		print "<TD align='right' BGCOLOR=$table1colour><TT> $connMASQcount</TT></TD>";
		print "<TD BGCOLOR=$table1colour><TT>&nbsp;connections</TT></TD>";
		print qq|
		<td BGCOLOR=$table1colour style='cursor: pointer' title="$connMASQcountESTABLISHED / $connMASQcountTCP established"><TT>TCP: $connMASQcountTCP</TT></TD>
		|;
		print "<TD BGCOLOR=$table1colour><TT>UDP: $connMASQcountUDP</TT></TD>";
		print "<TD BGCOLOR=$table1colour><TT>ICMP: $connMASQcountICMP</TT></TD>";
		print "<TD BGCOLOR=$table1colour><TT>OTHER: $connMASQcountOTHER</TT></TD>";
		print "</TR><TR>";
		print "<TD align='right' BGCOLOR=$table1colour><TT>Direct :  </TT></TD>";
		print "<TD align='right' BGCOLOR=$table1colour><TT> $connDIRECTcount</TT></TD>";
		print "<TD BGCOLOR=$table1colour><TT>&nbsp;connections</TT></TD>";
		print qq|
		<td BGCOLOR=$table1colour style='cursor: pointer' title="$connDIRECTcountESTABLISHED / $connDIRECTcountTCP established"><TT>TCP: $connDIRECTcountTCP</TT></TD>
		|;
		print "<TD BGCOLOR=$table1colour><TT>UDP: $connDIRECTcountUDP</TT></TD>"; 
		print "<TD BGCOLOR=$table1colour><TT>ICMP: $connDIRECTcountICMP</TT></TD>";
		print "<TD BGCOLOR=$table1colour><TT>OTHER: $connDIRECTcountOTHER</TT></TD>";
		print "</TR><TR>";
		print "<TD align='right' BGCOLOR=$table1colour><TT>Total :  </TT></TD>";
		print "<TD align='right' BGCOLOR=$table1colour><TT> $connTOTALcount</TT></TD>";
		print "<TD BGCOLOR=$table1colour><TT>&nbsp;connections</TT></TD>";
		print qq|
		<td BGCOLOR=$table1colour style='cursor: pointer' title="$connTOTALcountESTABLISHED / $connTOTALcountTCP established"><TT>TCP: $connTOTALcountTCP</TT></TD>
		|;
		print "<TD BGCOLOR=$table1colour><TT>UDP: $connTOTALcountUDP</TT></TD>";
		print "<TD BGCOLOR=$table1colour><TT>ICMP: $connTOTALcountICMP</TT></TD>";
		print "<TD BGCOLOR=$table1colour><TT>OTHER: $connTOTALcountOTHER</TT></TD>";
		print "</TR>";
		print "</TT></TD>";
		print "<TR></TABLE>";
		&closebox();
	}
}

sub connviewCOUNT {
	$connTOTALcount=$connTOTALcount+1;
	if ($catsrci ne $catdst2i) {
		$connMASQcount=$connMASQcount+1;
		if ($catstat eq "ESTABLISHED") { $connMASQcountESTABLISHED=$connMASQcountESTABLISHED+1; }
		if ($catprot eq "tcp") { $connMASQcountTCP=$connMASQcountTCP+1; 
		} elsif ($catprot eq "udp") { $connMASQcountUDP=$connMASQcountUDP+1; 
		} elsif ($catprot eq "icmp") { $connMASQcountICMP=$connMASQcountICMP+1; 
		} else { $connMASQcountOTHER=$connMASQcountOTHER+1; } 
	} elsif ($catsrci eq $catdst2i) {
		$connDIRECTcount=$connDIRECTcount+1;
		if ($catstat eq "ESTABLISHED") { $connDIRECTcountESTABLISHED=$connDIRECTcountESTABLISHED+1; }
		if ($catprot eq "tcp") { $connDIRECTcountTCP=$connDIRECTcountTCP+1; 
		} elsif ($catprot eq "udp") { $connDIRECTcountUDP=$connDIRECTcountUDP+1; 
		} elsif ($catprot eq "icmp") { $connDIRECTcountICMP=$connDIRECTcountICMP+1; 
		} else { $connDIRECTcountOTHER=$connDIRECTcountOTHER+1; } 
	}
}

sub connviewNETSTATdisplay {
	if ($connviewsettings{'CONN_NETSTAT'} eq "on") {
		&openbox("Netstat:<br>");
		print "<table width='100%' border='0' cellspacing='2' cellpadding=''>";
		print "<tr><td BGCOLOR=$table1colour>";
		print "<PRE>";
		if ($connviewsettings{'CONN_NAME'} eq "on") {
			system '/bin/netstat', '-alo';
		} else {
			system '/bin/netstat', '-alon';
		}
		print "</PRE>\n";
		print "</td></tr></table>";
		&closebox();
	}
}

sub connviewRAWdisplay {
	if (($connviewsettings{'CONN_RAW'} eq "on") || ($connviewsettings{'CONN_DISPLAY'} eq "raw")) {
		&openbox("Raw:<br>");
		print "<table width='100%' border='0' cellspacing='2' cellpadding=''>";
		$v=0;
		for ($i=0; $i <= $#ip_conntrack_data; $i++) {
			$raw = $ip_conntrack_data[$i];
			if ($v eq $i) {
				print "<TR BGCOLOR=$table1colour><TD><TT><font color=#000000>$raw</FONT></TT></TD></TR>";
				$v=$v+2;
			} else {
				print "<TR BGCOLOR=$table2colour><TD><TT><font color=#000000>$raw</FONT></TT></TD></TR>";
			}
		}
		print "</table>";
		&closebox();
	}
}

sub connviewNAME2 {
	my $catip = $_[0];
	if ($catip ne " ") { if ($catdnsname = gethostbyaddr(inet_aton($catip),AF_INET)) { } else { $catdnsname = $catip; } return $catdnsname; }
}

sub connviewNAME3 {
	my $catport = $_[0];
	my $catproto = $_[1];
	if ($catport ne " ") { if ($catportname = getservbyport $catport,$catproto) { } else { $catportname = $catport; } return $catportname; }
}

sub connviewMASQ {
	if ($catsrci ne $catdst2i) { $catmasq="M"; } else { $catmasq=""; }
}